﻿-- Author      : Grendizer@Doomhammer-EU
-- Create Date : 7/14/2011 1:51:48 PM

-- For testing Rejuvenation and LifeBloom
-- TrackedSpells = { 774, 33763 };

-- Vital Spark and Vital Flame
TrackedSpells = { 
	99262, -- vital spark
	99263, -- vital flame
	100230, -- Torment (25M Normal, we use spell name for detecting aura, so it shouldn't matter)
	99403 -- Tormented debuff
	 };

BHMSettings = {};


local function InitializeTrackedSpellNames()
	local tempNames = {}
	for i, id in pairs(TrackedSpells) do
		local spellName = GetSpellInfo(id);
		tempNames[i] = spellName;
	end
	return tempNames
end

TrackedSpellNames = InitializeTrackedSpellNames()


function BHMOptionsFrame_OnLoad(panel)
	panel.name = BALEROCHEALINGMONITOR_ADDON_TITLE;
	InterfaceOptions_AddCategory(panel);
	SlashCmdList["BALEROCHEALMONITOR"] = BHM_Slashes
	SLASH_BALEROCHEALMONITOR1 = "/balerochealmonitor"
	SLASH_BALEROCHEALMONITOR2 = "/balerochealingmonitor"
	SLASH_BALEROCHEALMONITOR3 = "/bhm"
	
	DEFAULT_CHAT_FRAME:AddMessage(BALEROCHEALINGMONITOR_ADDON_WELCOME);
	
	BHMOptionsFrameBarWidthText:SetText(BALEROCHEALINGMONITOR_OPTIONS_BARWIDTH);
	BHMOptionsFrameBarHeightText:SetText(BALEROCHEALINGMONITOR_OPTIONS_BARHEIGHT);
	BHMOptionsFrameBarFontText:SetText(BALEROCHEALINGMONITOR_OPTIONS_BARFONT);
	BHMOptionsFrameBarOpacityText:SetText(BALEROCHEALINGMONITOR_OPTIONS_BAROPACITY);
	
	BHMOptionsFrame_CreateSpellToggles(panel);
end

local function GetStrippedFrameName(frame)
	local name = frame:GetName();
	name = string.gsub(name, "BHMOptionsFrame", "");
	name = string.gsub(name, "_", "");
	name = string.gsub(name, "Toggle", "");
	return name;
end

function BHMOptionsFrame_SaveSliderValue(slide)
	local name = GetStrippedFrameName(slide);
	BHMSettings[name] = slide:GetValue();
	BarCollection.ResizeAll()
end

function BHMOptionsFrame_LoadSliderValue(slide)
	local name = GetStrippedFrameName(slide);
	local value = BHMSettings[name];
	if value == nil then 
		value = 50;
	end
	if value ~= slide:GetValue() then
		slide:SetValue(value);
	end
end

function BHMOptionsFrame_SaveToggleValue(toggle)
	local name = GetStrippedFrameName(toggle);
	BHMSettings[name] = 1 - (BHMSettings[name] or 1);
	BarCollection.EnableCollection(name);
end

function BHMOptionsFrame_LoadToggleValue(toggle)
	local name = GetStrippedFrameName(toggle);
	local value = BHMSettings[name];
	if value == nil then
		value = 1;
	end
	if value ~= toggle:GetChecked() then
		toggle:SetChecked(value);
	end
end

function BHMOptionsFrame_CreateSpellToggles(panel)
	local prevToggle = nil;
	for i, spellName in pairs(TrackedSpellNames) do
		local frameName = "BHMOptionsFrame_" .. spellName .. "_Toggle";
		local toggleFrame = CreateFrame("CheckButton", frameName, panel, "BHMCheckButton");
		if prevToggle ~= nil then
			toggleFrame:SetPoint("TOPLEFT", prevToggle, "BOTTOMLEFT", 0, -16);
		else
			toggleFrame:SetPoint("TOPLEFT", "BHMOptionsFrameBarWidth", "TOPRIGHT", 100, 0);
		end
		prevToggle = frameName;
		_G[frameName.."Text"]:SetText(format(BALEROCHEALINGMONITOR_OPTIONS_TOGGLESPELL, spellName));
	end		
end

function BHM_Slashes(msg)
	if msg==BALEROCHEALMONITOR_SLASHCOMMAND_LOCK or msg== BALEROCHEALMONITOR_SLASHCOMMAND_MOVE then
		--BHM_Move()
	else
		BHM_OpenOptions() 
	end
end

function BHM_OpenOptions()
	InterfaceOptionsFrame_OpenToCategory(BHMOptionsFrame)
end

function BHM_TestModeToggle()
	if TestMode == 0 then
		BHMOptionsFrameTestMode:SetText(BALEROCHEALINGMONITOR_OPTIONS_TESTMODE_OFF);
		TestMode = 1
	else
		BHMOptionsFrameTestMode:SetText(BALEROCHEALINGMONITOR_OPTIONS_TESTMODE_ON);
		TestMode = 0
	end
	BarCollection.EnableAll();
end